/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export type OpaqueString<Key extends string> = string & {
    __opaque: Key;
};

export type ProjectId = OpaqueString<"ProjectId">;

export interface IProjectOmitId {
    name: string;
    description?: string;
}

export interface ICreatableProject extends IProjectOmitId {
}

export interface ProjectCreateBody {
    project: ICreatableProject;
}

export interface IProject {
    id: ProjectId;
    name: string;
    description?: string;
}

export interface ISearchResponsePaging {
    current: string;
    previous?: string;
    next?: string;
}

export interface ISearchResponse_IProject {
    paging?: ISearchResponsePaging;
    items: IProject[];
    itemCount: number;
}

export interface IPagination {
    page?: string;
    pageSize?: number;
}

export enum QueryOperator {
    between = "between",
    equals = "equals",
    like = "like",
    lessThanOrEqual = "lessThanOrEqual",
    greaterThanOrEqual = "greaterThanOrEqual"
}

export interface IQueryWhere {
    key: string;
    operator: QueryOperator;
    valueOne: any;
    valueTwo?: any;
}

export interface IQuery {
    where: IQueryWhere[];
}

export interface IProjectsQuery extends IPagination, IQuery {
}

export interface ProjectGetByIdParams {
    projectId: ProjectId;
}

export type ProjectUnitInstanceId = OpaqueString<"ProjectUnitInstanceId">;

export type ProjectUnitId = OpaqueString<"ProjectUnitId">;

export interface IProjectUnitInstance {
    id: ProjectUnitInstanceId;
    projectUnitId: ProjectUnitId;
}

export type SceneId = OpaqueString<"SceneId">;

export enum AssetKind {
    Image = "Image",
    Video = "Video",
    ImageOrVideo = "ImageOrVideo",
    ThreeDimensional = "ThreeDimensional",
    Audio = "Audio"
}

export type AspectRatioName = OpaqueString<"AspectRatioName">;

export interface IImageAssetPublisherMetadata {
    kind: AssetKind.Image;
    aspectRatio: AspectRatioName;
}

export interface IVideoAssetPublisherMetadata {
    kind: AssetKind.Video;
    aspectRatio: AspectRatioName;
    isMuted: boolean;
    maxLengthInSeconds: number;
}

export enum ImageOrVideoPreference {
    Image = "Image",
    Video = "Video"
}

export interface IImageAssetPublisherMetadataOmitKind {
    aspectRatio: AspectRatioName;
}

export interface IVideoAssetPublisherMetadataOmitKind {
    aspectRatio: AspectRatioName;
    isMuted: boolean;
    maxLengthInSeconds: number;
}

export interface IImageOrVideoAssetPublisherMetadata extends IImageAssetPublisherMetadataOmitKind, IVideoAssetPublisherMetadataOmitKind {
    kind: AssetKind.ImageOrVideo;
    preference: ImageOrVideoPreference;
}

export interface IAudioAssetPublisherMetadata {
    kind: AssetKind.Audio;
    maxLengthInSeconds: number;
}

export interface IThreeDimensionalAssetPublisherMetadata {
    kind: AssetKind.ThreeDimensional;
    isMovable: boolean;
}

export type ProjectUnitMetadata = IImageAssetPublisherMetadata | IVideoAssetPublisherMetadata | IImageOrVideoAssetPublisherMetadata | IAudioAssetPublisherMetadata | IThreeDimensionalAssetPublisherMetadata;

export interface IProjectUnit {
    id: ProjectUnitId;
    sceneId: SceneId;
    name?: string;
    description?: string;
    metadata: ProjectUnitMetadata;
}

export type TagName = OpaqueString<"TagName">;

export interface ITaggable {
    mandatoryTags: TagName[];
    excludedTags: TagName[];
}

export interface IProjectUnitResponse extends IProjectUnit, ITaggable {
    instances: IProjectUnitInstance[];
}

export interface ProjectGetUnitsBySceneParams {
    projectId: ProjectId;
    sceneId: SceneId;
}

export interface IProjectUnitOmitId {
    sceneId: SceneId;
    name?: string;
    description?: string;
    metadata: ProjectUnitMetadata;
}

export interface ICreatableProjectUnit extends IProjectUnitOmitId, ITaggable {
}

export interface ISceneOmitId {
    projectId: ProjectId;
    name: string;
    description?: string;
}

export interface ICreatableScene extends ISceneOmitId {
}

export interface SceneCreateBody {
    scene: ICreatableScene;
}

export interface IScene {
    id: SceneId;
    projectId: ProjectId;
    name: string;
    description?: string;
}

export interface SceneGetScenesByProjectIdParams {
    id: ProjectId;
}

export class ProjectController {
    constructor(private fetcher: IFetcher) { }
    create = (body: ProjectCreateBody, headers?: HeaderMap): Promise<IProject> => {
        return this.fetcher.request<IProject>(`projects/`, "post", "application/json", body, headers);
    };
    getMyProjects = (query?: IProjectsQuery, headers?: HeaderMap): Promise<ISearchResponse_IProject> => {
        return this.fetcher.request<ISearchResponse_IProject>(`projects/my${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
    getById = (params: ProjectGetByIdParams, headers?: HeaderMap): Promise<IProject> => {
        return this.fetcher.request<IProject>(`projects/${params.projectId}`, "get", "application/json", undefined, headers);
    };
    getUnitsByScene = (params: ProjectGetUnitsBySceneParams, headers?: HeaderMap): Promise<IProjectUnitResponse[]> => {
        return this.fetcher.request<IProjectUnitResponse[]>(`projects/${params.projectId}/scenes/${params.sceneId}/units`, "get", "application/json", undefined, headers);
    };
}

export class ProjectUnitController {
    constructor(private fetcher: IFetcher) { }
    create = (body: ICreatableProjectUnit, headers?: HeaderMap): Promise<IProjectUnit> => {
        return this.fetcher.request<IProjectUnit>(`project-units/`, "post", "application/json", body, headers);
    };
}

export class SceneController {
    constructor(private fetcher: IFetcher) { }
    create = (body: SceneCreateBody, headers?: HeaderMap): Promise<IScene> => {
        return this.fetcher.request<IScene>(`scenes/`, "post", "application/json", body, headers);
    };
    getScenesByProjectId = (params: SceneGetScenesByProjectIdParams, headers?: HeaderMap): Promise<IScene[]> => {
        return this.fetcher.request<IScene[]>(`scenes/${params.id}`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    project = new ProjectController(this.fetcher);
    projectUnit = new ProjectUnitController(this.fetcher);
    scene = new SceneController(this.fetcher);
}